// WD_Test_SoftwareDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WD_Test_Software.h"
#include "WD_Test_SoftwareDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//*******Global Variables
struct SaveRecordO
{
	char App11[30];
	char App22[30];
	char App33[30];
	char App44[30];
	char App55[30];
	int Frequency[5];
	BOOL ResetMotherBoard[5];
	BOOL ResetPowerBox[5];
	int RestartBox[5];
	BOOL CalendarStartT;
	BOOL ProgramStartedT;
	char StartDate[10];
	char StopDate[10];
	int  StartHour, StartMin, StopHour, StopMin;
}SaveRecord;

static int Oindex=0;
FILE *fp;
BOOL CalendarStart=FALSE;
int  StartMonth,StartDay,StopMonth,StopDay;
BOOL ProgramStarted=FALSE;
int  CurrentFreq[5]={-1,-1,-1,-1,-1};
int  RestartTimer[5]={99,99,99,99,99};
static int special=0;
static HWND h;
int  Flag1=0;   //this is to avoid accessing of 
                //variables at the same time


//***********************


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWD_Test_SoftwareDlg dialog

CWD_Test_SoftwareDlg::CWD_Test_SoftwareDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWD_Test_SoftwareDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWD_Test_SoftwareDlg)
	m_resetbox1 = FALSE;
	m_resetbox2 = FALSE;
	m_resetbox3 = FALSE;
	m_resetbox4 = FALSE;
	m_resetbox5 = FALSE;
	m_resetmb1 = FALSE;
	m_resetmb2 = FALSE;
	m_resetmb3 = FALSE;
	m_resetmb4 = FALSE;
	m_resetmb5 = FALSE;
	m_app1 = _T("");
	m_app2 = _T("");
	m_app3 = _T("");
	m_app4 = _T("");
	m_app5 = _T("");
	m_counter1 = 0;
	m_counter2 = 0;
	m_counter3 = 0;
	m_counter4 = 0;
	m_counter5 = 0;
	m_freq1 = 0;
	m_freq2 = 0;
	m_freq3 = 0;
	m_freq4 = 0;
	m_freq5 = 0;
	m_restartbox1 = 99;
	m_restartbox2 = 99;
	m_restartbox3 = 99;
	m_restartbox4 = 99;
	m_restartbox5 = 99;
	m_startdate = _T("00/00");
	m_starthour = 99;
	m_startmin = 99;
	m_stopdate = _T("99/99");
	m_stophour = 99;
	m_stopmin = 99;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWD_Test_SoftwareDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWD_Test_SoftwareDlg)
	DDX_Check(pDX, IDC_Cresetbox1, m_resetbox1);
	DDX_Check(pDX, IDC_Cresetbox2, m_resetbox2);
	DDX_Check(pDX, IDC_Cresetbox3, m_resetbox3);
	DDX_Check(pDX, IDC_Cresetbox4, m_resetbox4);
	DDX_Check(pDX, IDC_Cresetbox5, m_resetbox5);
	DDX_Check(pDX, IDC_Cresetmb1, m_resetmb1);
	DDX_Check(pDX, IDC_Cresetmb2, m_resetmb2);
	DDX_Check(pDX, IDC_Cresetmb3, m_resetmb3);
	DDX_Check(pDX, IDC_Cresetmb4, m_resetmb4);
	DDX_Check(pDX, IDC_Cresetmb5, m_resetmb5);
	DDX_Text(pDX, IDC_Eapp1, m_app1);
	DDX_Text(pDX, IDC_Eapp2, m_app2);
	DDX_Text(pDX, IDC_Eapp3, m_app3);
	DDX_Text(pDX, IDC_Eapp4, m_app4);
	DDX_Text(pDX, IDC_Eapp5, m_app5);
	DDX_Text(pDX, IDC_Ecounter1, m_counter1);
	DDX_Text(pDX, IDC_Ecounter2, m_counter2);
	DDX_Text(pDX, IDC_Ecounter3, m_counter3);
	DDX_Text(pDX, IDC_Ecounter4, m_counter4);
	DDX_Text(pDX, IDC_Ecounter5, m_counter5);
	DDX_Text(pDX, IDC_Efreq1, m_freq1);
	DDX_Text(pDX, IDC_Efreq2, m_freq2);
	DDX_Text(pDX, IDC_Efreq3, m_freq3);
	DDX_Text(pDX, IDC_Efreq4, m_freq4);
	DDX_Text(pDX, IDC_Efreq5, m_freq5);
	DDX_Text(pDX, IDC_Erestartbox1, m_restartbox1);
	DDX_Text(pDX, IDC_Erestartbox2, m_restartbox2);
	DDX_Text(pDX, IDC_Erestartbox3, m_restartbox3);
	DDX_Text(pDX, IDC_Erestartbox4, m_restartbox4);
	DDX_Text(pDX, IDC_Erestartbox5, m_restartbox5);
	DDX_Text(pDX, IDC_Estartdate, m_startdate);
	DDX_Text(pDX, IDC_Estarthour, m_starthour);
	DDX_Text(pDX, IDC_Estartmin, m_startmin);
	DDX_Text(pDX, IDC_Estopdate, m_stopdate);
	DDX_Text(pDX, IDC_Estophour, m_stophour);
	DDX_Text(pDX, IDC_Estopmin, m_stopmin);
	DDX_Control(pDX, IDC_WATCHDOGOCXCTRL1, m_WD);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWD_Test_SoftwareDlg, CDialog)
	//{{AFX_MSG_MAP(CWD_Test_SoftwareDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_Bsetstart, OnBsetstart)
	ON_BN_CLICKED(IDC_Bsetstop, OnBsetstop)
	ON_BN_CLICKED(IDC_BStartNow, OnBStartNow)
	ON_BN_CLICKED(IDC_BStopNow, OnBStopNow)
	ON_BN_CLICKED(IDC_Bsave, OnBsave)
	ON_WM_COPYDATA()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWD_Test_SoftwareDlg message handlers

BOOL CWD_Test_SoftwareDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	fp=fopen("c:\\wdconf.log","rb");
	if (fp != NULL)
	{
		fread(&SaveRecord,sizeof(SaveRecordO),1,fp);
		fclose(fp);
		m_app1=SaveRecord.App11;
		m_app2=SaveRecord.App22;
		m_app3=SaveRecord.App33;
		m_app4=SaveRecord.App44;
		m_app5=SaveRecord.App55;

		m_freq1=SaveRecord.Frequency[0];
		m_freq2=SaveRecord.Frequency[1];
		m_freq3=SaveRecord.Frequency[2];
		m_freq4=SaveRecord.Frequency[3];
		m_freq5=SaveRecord.Frequency[4];

		m_resetmb1=SaveRecord.ResetMotherBoard[0];
		m_resetmb2=SaveRecord.ResetMotherBoard[1];
		m_resetmb3=SaveRecord.ResetMotherBoard[2];
		m_resetmb4=SaveRecord.ResetMotherBoard[3];
		m_resetmb5=SaveRecord.ResetMotherBoard[4];

		m_resetbox1=SaveRecord.ResetPowerBox[0];
		m_resetbox2=SaveRecord.ResetPowerBox[1];
		m_resetbox3=SaveRecord.ResetPowerBox[2];
		m_resetbox4=SaveRecord.ResetPowerBox[3];
		m_resetbox5=SaveRecord.ResetPowerBox[4];

		m_restartbox1=SaveRecord.RestartBox[0];
		m_restartbox2=SaveRecord.RestartBox[1];
		m_restartbox3=SaveRecord.RestartBox[2];
		m_restartbox4=SaveRecord.RestartBox[3];
		m_restartbox5=SaveRecord.RestartBox[4];

		ProgramStarted = SaveRecord.ProgramStartedT;
		CalendarStart = SaveRecord.CalendarStartT;
		m_startdate = SaveRecord.StartDate;
		m_stopdate = SaveRecord.StopDate;
		m_starthour = SaveRecord.StartHour;
		m_stophour = SaveRecord.StopHour;
		m_startmin = SaveRecord.StartMin;
		m_stopmin = SaveRecord.StopMin;

		if (m_app1.GetLength())
		{
			CurrentFreq[0]=m_freq1;
			RestartTimer[0]=m_restartbox1;
		}
		if (m_app2.GetLength())
		{
			CurrentFreq[1]=m_freq2;
			RestartTimer[1]=m_restartbox2;
		}
		if (m_app3.GetLength())
		{
			CurrentFreq[2]=m_freq3;
			RestartTimer[2]=m_restartbox3;
		}
		if (m_app4.GetLength())
		{
			CurrentFreq[3]=m_freq4;
			RestartTimer[3]=m_restartbox4;
		}
		if (m_app5.GetLength())
		{
			CurrentFreq[4]=m_freq5;
			RestartTimer[4]=m_restartbox5;
		}
		

		UpdateData(FALSE);
	}
	SetTimer(1,1000,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWD_Test_SoftwareDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWD_Test_SoftwareDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWD_Test_SoftwareDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void PostIT (LPCSTR MessageToBePosted,DWORD value, HWND TargetHandle)
{
	COPYDATASTRUCT cd; 
	
	
	cd.dwData = value;
	cd.cbData = (strlen(MessageToBePosted)+1)*sizeof(char);
	cd.lpData = (void *)MessageToBePosted;
	::SendMessage (TargetHandle, WM_COPYDATA, 0, (LPARAM)&cd);
		
}

void CWD_Test_SoftwareDlg::ProceedProcess(CString AppName, 
										  int resetmb,
										  int resetbox,
										  int OFreq,
										  int *Freq, 
										  int *Restart, 
										  int *Counter)
{
	if (*Freq != -1) //Monitor Process?
	{
		if (*Freq != 0) //Is the freq up?
			*Freq-=1;

		else //timer is up
		{		//is ap active?
////////////////////////////////////////////////////////////////////////
			unsigned long * lpdwResult = 0;	
			if(	0 == SendMessageTimeout(  ::FindWindow(NULL,AppName),
										WM_NULL,
										WM_NULL,
										WM_NULL,
										SMTO_ABORTIFHUNG,
										1,
										NULL	)	)			
/////////////////////////////////////////////////////////////////////////////////
			{//nope, its not
				
				*Freq=-1;
				if (resetmb == TRUE)
					m_WD.SetTimeUnit(1);///reset for Watchdog///
					m_WD.SetCounter(1);
					m_WD.EnableorLoad();
				if (resetbox == TRUE)
					m_WD.PowerOFF(); ///turn OFF the Watchdog box//
			}
			
			else
			{//its still active
				*Freq = OFreq;
				*Counter+=1;
			}
		}
	}

	
	else 
		if (*Restart != 99)  //Monitor Restart Time?
		{
			if (*Restart != 0) //Is the restart up?
				*Restart-=1;
			else //restart is up
			{
				m_WD.PowerON(); //turn ON the box again
				*Restart=99;
				*Freq=-1;
			}
		}
}

void CWD_Test_SoftwareDlg::OnTimer(UINT nIDEvent) 
{
	CTime CT;     //for clock display
	CString str1; //for clock display
	
	
	// TODO: Add your message handler code here and/or call default
	if (special == 2) 
	{
		if (Oindex == 0) //first ap
		{
			PostIT((LPCSTR) m_app1,0x21000000,h);  //Name
			PostIT(TEXT("Hi"), 0x22000000 + m_freq1, h); //Freq
			PostIT(TEXT("Hi"), 0x23000000 + m_resetmb1, h); //Option1
			PostIT(TEXT("Hi"), 0x24000000 + m_resetbox1, h); //Option2
			PostIT(TEXT("Hi"), 0x25000000 + m_restartbox1, h); //Option3
		}
		if (Oindex == 1) //second ap
		{
			PostIT((LPCSTR) m_app2,0x21000000,h);  //Name
			PostIT(TEXT("Hi"), 0x22000000 + m_freq2, h); //Freq
			PostIT(TEXT("Hi"), 0x23000000 + m_resetmb2, h); //Option1
			PostIT(TEXT("Hi"), 0x24000000 + m_resetbox2, h); //Option2
			PostIT(TEXT("Hi"), 0x25000000 + m_restartbox2, h); //Option3
		}
		if (Oindex == 2) //third ap
		{
			PostIT((LPCSTR) m_app3,0x21000000,h);  //Name
			PostIT(TEXT("Hi"), 0x22000000 + m_freq3, h); //Freq
			PostIT(TEXT("Hi"), 0x23000000 + m_resetmb3, h); //Option1
			PostIT(TEXT("Hi"), 0x24000000 + m_resetbox3, h); //Option2
			PostIT(TEXT("Hi"), 0x25000000 + m_restartbox3, h); //Option3
		}
		if (Oindex == 3) //fourth ap
		{
			PostIT((LPCSTR) m_app4,0x21000000,h);  //Name
			PostIT(TEXT("Hi"), 0x22000000 + m_freq4, h); //Freq
			PostIT(TEXT("Hi"), 0x23000000 + m_resetmb4, h); //Option1
			PostIT(TEXT("Hi"), 0x24000000 + m_resetbox4, h); //Option2
			PostIT(TEXT("Hi"), 0x25000000 + m_restartbox4, h); //Option3
		}
		if (Oindex == 4) //fifth ap
		{
			PostIT((LPCSTR) m_app5,0x21000000,h);  //Name
			PostIT(TEXT("Hi"), 0x22000000 + m_freq5, h); //Freq
			PostIT(TEXT("Hi"), 0x23000000 + m_resetmb5, h); //Option1
			PostIT(TEXT("Hi"), 0x24000000 + m_resetbox5, h); //Option2
			PostIT(TEXT("Hi"), 0x25000000 + m_restartbox5, h); //Option3
		}
		special=0;
	}

	if (special == 4) 
	{
			PostIT((LPCSTR) m_startdate,0x30000000,h);  //Name
			PostIT((LPCSTR) m_stopdate,0x31000000,h);  //Name
			PostIT(TEXT("Hi"), 0x32000000 + m_starthour, h); //Freq
			PostIT(TEXT("Hi"), 0x33000000 + m_startmin, h); //Option1
			PostIT(TEXT("Hi"), 0x34000000 + m_stophour, h); //Option2
			PostIT(TEXT("Hi"), 0x35000000 + m_stopmin, h); //Option3
			special=0;
	}

	if (nIDEvent == 1)
	{
		CT=CTime::GetCurrentTime();
		str1=CT.Format("%H:%M:%S");
		
		GetDlgItem(IDC_Stime)->SetWindowText(str1);
		

		if (CalendarStart == TRUE)
		{
			if (ProgramStarted == FALSE)
			{
				if ((CT.GetMonth() == StartMonth) && (CT.GetDay() == StartDay) &&
				    (CT.GetHour() == m_starthour) && (CT.GetMinute() == m_startmin))
					ProgramStarted = TRUE;
			}
			else 
				if ((CT.GetMonth() == StopMonth) && (CT.GetDay() == StopDay) &&
				    (CT.GetHour() == m_stophour) && (CT.GetMinute() == m_stopmin))
				{
					ProgramStarted = FALSE;
					CalendarStart = FALSE;
				}
		}
		
		if (ProgramStarted==TRUE)
		{
			while (Flag1) //Protect for simultaneous access
			{
				Sleep(0);
			}
			UpdateData(TRUE);

		ProceedProcess(m_app1, m_resetmb1, m_resetbox1,
										  m_freq1,
										  &CurrentFreq[0], 
										  &RestartTimer[0], 
										  &m_counter1);

		ProceedProcess(m_app2, m_resetmb2, m_resetbox2,
										  m_freq2,
										  &CurrentFreq[1], 
										  &RestartTimer[1], 
										  &m_counter2);

		ProceedProcess(m_app3, m_resetmb3, m_resetbox3,
										  m_freq3,
										  &CurrentFreq[2], 
										  &RestartTimer[2], 
										  &m_counter3);

		ProceedProcess(m_app4, m_resetmb4, m_resetbox4,
										  m_freq4,
										  &CurrentFreq[3], 
										  &RestartTimer[3], 
										  &m_counter4);

		ProceedProcess(m_app5, m_resetmb5, m_resetbox5,
										  m_freq5,
										  &CurrentFreq[4], 
										  &RestartTimer[4], 
										  &m_counter5);
		 UpdateData(FALSE);
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CWD_Test_SoftwareDlg::OnBsetstart() 
{
	// TODO: Add your control notification handler code here
	Flag1+=1;
	UpdateData(TRUE);
	if (m_app1.GetLength())
	{
		CalendarStart=TRUE;
		CurrentFreq[0]=m_freq1;
		RestartTimer[0]=m_restartbox1;
	}
	if (m_app2.GetLength())
	{
		CalendarStart=TRUE;
		CurrentFreq[1]=m_freq2;
		RestartTimer[1]=m_restartbox2;
	}
	if (m_app3.GetLength())
	{
		CalendarStart=TRUE;
		CurrentFreq[2]=m_freq3;
		RestartTimer[2]=m_restartbox3;
	}
	if (m_app4.GetLength())
	{
		CalendarStart=TRUE;
		CurrentFreq[3]=m_freq4;
		RestartTimer[3]=m_restartbox4;
	}
	if (m_app5.GetLength())
	{
		CalendarStart=TRUE;
		CurrentFreq[4]=m_freq5;
		RestartTimer[4]=m_restartbox5;
	}
	Flag1-=1;
	sscanf(m_startdate,"%d/%d",&StartMonth,&StartDay);
}

void CWD_Test_SoftwareDlg::OnBsetstop() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	sscanf(m_startdate,"%d/%d",&StopMonth,&StopDay);
}

void CWD_Test_SoftwareDlg::OnBStartNow() 
{
	CTime CT;
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	Flag1+=1;
	CT=CTime::GetCurrentTime();
	m_startdate=CT.Format("%m/%d");
	m_starthour=CT.GetHour();
	m_startmin=CT.GetMinute();
	UpdateData(FALSE);
	UpdateData(TRUE);

	if (m_app1.GetLength())
	{
		ProgramStarted=TRUE;
		CurrentFreq[0]=m_freq1;
		RestartTimer[0]=m_restartbox1;
	}
	if (m_app2.GetLength())
	{
		ProgramStarted=TRUE;
		CurrentFreq[1]=m_freq2;
		RestartTimer[1]=m_restartbox2;
	}
	if (m_app3.GetLength())
	{
		ProgramStarted=TRUE;
		CurrentFreq[2]=m_freq3;
		RestartTimer[2]=m_restartbox3;
	}
	if (m_app4.GetLength())
	{
		ProgramStarted=TRUE;
		CurrentFreq[3]=m_freq4;
		RestartTimer[3]=m_restartbox4;
	}
	if (m_app5.GetLength())
	{
		ProgramStarted=TRUE;
		CurrentFreq[4]=m_freq5;
		RestartTimer[4]=m_restartbox5;
	}
	Flag1-=1;
}

void CWD_Test_SoftwareDlg::OnBStopNow() 
{
	CTime CT;
	// TODO: Add your control notification handler code here
	Flag1+=1;
	CT=CTime::GetCurrentTime();
	m_stopdate=CT.Format("%m/%d");
	m_stophour=CT.GetHour();
	m_stopmin=CT.GetMinute();
	UpdateData(FALSE);
	ProgramStarted=FALSE;
	Flag1-=1;
}

void CWD_Test_SoftwareDlg::OnBsave() 
{
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	strcpy(SaveRecord.App11,m_app1);
	strcpy(SaveRecord.App22,m_app2);
	strcpy(SaveRecord.App33,m_app3);
	strcpy(SaveRecord.App44,m_app4);
	strcpy(SaveRecord.App55,m_app5);

	SaveRecord.Frequency[0]=m_freq1;
	SaveRecord.Frequency[1]=m_freq2;
	SaveRecord.Frequency[2]=m_freq3;
	SaveRecord.Frequency[3]=m_freq4;
	SaveRecord.Frequency[4]=m_freq5;

	SaveRecord.ResetMotherBoard[0]=m_resetmb1;
	SaveRecord.ResetMotherBoard[1]=m_resetmb2;
	SaveRecord.ResetMotherBoard[2]=m_resetmb3;
	SaveRecord.ResetMotherBoard[3]=m_resetmb4;
	SaveRecord.ResetMotherBoard[4]=m_resetmb5;

	SaveRecord.ResetPowerBox[0]=m_resetbox1;
	SaveRecord.ResetPowerBox[1]=m_resetbox2;
	SaveRecord.ResetPowerBox[2]=m_resetbox3;
	SaveRecord.ResetPowerBox[3]=m_resetbox4;
	SaveRecord.ResetPowerBox[4]=m_resetbox5;

	SaveRecord.RestartBox[0]=m_restartbox1;
	SaveRecord.RestartBox[1]=m_restartbox2;
	SaveRecord.RestartBox[2]=m_restartbox3;
	SaveRecord.RestartBox[3]=m_restartbox4;
	SaveRecord.RestartBox[4]=m_restartbox5;

	SaveRecord.ProgramStartedT= ProgramStarted;
	SaveRecord.CalendarStartT = CalendarStart;
	strcpy(SaveRecord.StartDate,m_startdate);
	strcpy(SaveRecord.StopDate,m_stopdate);
	SaveRecord.StartHour = m_starthour;
	SaveRecord.StopHour = m_stophour;
	SaveRecord.StartMin = m_startmin;
	SaveRecord.StopMin = m_stopmin;
	
	
	fp=fopen("c:\\wdconf.log","wb");
	fwrite(&SaveRecord,sizeof(SaveRecordO),1,fp);
	fclose(fp);
	
}



BOOL CWD_Test_SoftwareDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	TCHAR DataToPost[2000];
	long freq;
	int index=0;
	
	
	
	// TODO: Add your message handler code here and/or call default
	
	memset(DataToPost,0x00,2000);
	wsprintf (DataToPost, "%s", (LPCTSTR)pCopyDataStruct->lpData);

	if (special==1)
	{
		h= (HWND)pCopyDataStruct->dwData;
		special=2;
	}

	if (special==3)
	{
		h= (HWND)pCopyDataStruct->dwData;
		special=4;
	}

	if (pCopyDataStruct->dwData == 0x70000000)		
		OnBsave();
	
	if ((pCopyDataStruct->dwData >= 0x60000000) &&
		(pCopyDataStruct->dwData <  0x61000000))
	{
		if ((pCopyDataStruct->dwData - 0x60000000) == 0)
			OnBStopNow();
		else OnBStartNow();
	}

	if ((pCopyDataStruct->dwData >= 0x40000000) &&
		(pCopyDataStruct->dwData <  0x41000000) && (special == 0))
	{
		special=1;
		Oindex=pCopyDataStruct->dwData - 0x40000000;
	}

	if (pCopyDataStruct->dwData == 0x50000000) 
		special=3;

	if (pCopyDataStruct->dwData < 0x22000000) 
	{//for Name
		index=pCopyDataStruct->dwData - 0x21000000;
		if (index == 0)
			m_app1 = DataToPost;
		if (index == 1)
			m_app2 = DataToPost;
		if (index == 2)
			m_app3 = DataToPost;
		if (index == 3)
			m_app4 = DataToPost;
		if (index == 4)
			m_app5 = DataToPost;
		
	} else
	if ((pCopyDataStruct->dwData >= 0x22000000) && (pCopyDataStruct->dwData < 0x23000000))
	{//for Freq
		freq=pCopyDataStruct->dwData - 0x22000000;
		if (index == 0)
			m_freq1 = freq;
		if (index == 1)
			m_freq2 = freq;
		if (index == 2)
			m_freq3 = freq;
		if (index == 3)
			m_freq4 = freq;
		if (index == 4)
			m_freq5 = freq;
		
	} else
	if ((pCopyDataStruct->dwData >= 0x23000000) && (pCopyDataStruct->dwData < 0x24000000))
	{//for ResetMB
		if (index == 0)
			m_resetmb1 = pCopyDataStruct->dwData - 0x23000000;
		if (index == 1)
			m_resetmb2 = pCopyDataStruct->dwData - 0x23000000;
		if (index == 2)
			m_resetmb3 = pCopyDataStruct->dwData - 0x23000000;
		if (index == 3)
			m_resetmb4 = pCopyDataStruct->dwData - 0x23000000;
		if (index == 4)
			m_resetmb5 = pCopyDataStruct->dwData - 0x23000000;
		
	} else
	if ((pCopyDataStruct->dwData >= 0x24000000) && (pCopyDataStruct->dwData < 0x25000000))
	{//for ResetBox
		if (index == 0)
			m_resetbox1 = pCopyDataStruct->dwData - 0x24000000;
		if (index == 1)
			m_resetbox2 = pCopyDataStruct->dwData - 0x24000000;
		if (index == 2)
			m_resetbox3 = pCopyDataStruct->dwData - 0x24000000;
		if (index == 3)
			m_resetbox4 = pCopyDataStruct->dwData - 0x24000000;
		if (index == 4)
			m_resetbox5 = pCopyDataStruct->dwData - 0x24000000;
		
	} else
	if ((pCopyDataStruct->dwData >= 0x25000000) && (pCopyDataStruct->dwData < 0x26000000))
	{//for RestartBox
		if (index == 0)
			m_restartbox1 = pCopyDataStruct->dwData - 0x25000000;
		if (index == 1)
			m_restartbox2 = pCopyDataStruct->dwData - 0x25000000;
		if (index == 2)
			m_restartbox3 = pCopyDataStruct->dwData - 0x25000000;
		if (index == 3)
			m_restartbox4 = pCopyDataStruct->dwData - 0x25000000;
		if (index == 4)
			m_restartbox5 = pCopyDataStruct->dwData - 0x25000000;
		
	} else
	if ((pCopyDataStruct->dwData >= 0x31000000) && (pCopyDataStruct->dwData < 0x32000000))
		m_startdate = DataToPost;
	else
	if ((pCopyDataStruct->dwData >= 0x32000000) && (pCopyDataStruct->dwData < 0x33000000))
		m_starthour = pCopyDataStruct->dwData - 0x32000000;
	else
	if ((pCopyDataStruct->dwData >= 0x33000000) && (pCopyDataStruct->dwData < 0x34000000))
		m_startmin = pCopyDataStruct->dwData - 0x33000000;
	else
	if ((pCopyDataStruct->dwData >= 0x34000000) && (pCopyDataStruct->dwData < 0x35000000))
		m_stopdate = DataToPost;
	else
	if ((pCopyDataStruct->dwData >= 0x35000000) && (pCopyDataStruct->dwData < 0x36000000))
		m_stophour = pCopyDataStruct->dwData - 0x35000000;
	else
	if ((pCopyDataStruct->dwData >= 0x36000000) && (pCopyDataStruct->dwData < 0x37000000))
	{
		m_stopmin = pCopyDataStruct->dwData - 0x36000000;
		UpdateData(FALSE);
		OnBsetstart();
	}
	
	
		
	
	UpdateData(FALSE);
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}
