// WD_Test_SoftwareDlg.h : header file
//
//{{AFX_INCLUDES()
#include "watchdog_ocx.h"
//}}AFX_INCLUDES

#if !defined(AFX_WD_TEST_SOFTWAREDLG_H__6679B5A1_C191_439A_97FB_7B41EF9ABCF8__INCLUDED_)
#define AFX_WD_TEST_SOFTWAREDLG_H__6679B5A1_C191_439A_97FB_7B41EF9ABCF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CWD_Test_SoftwareDlg dialog

class CWD_Test_SoftwareDlg : public CDialog
{
// Construction
public:
	CWD_Test_SoftwareDlg(CWnd* pParent = NULL);	// standard constructor
	void ProceedProcess(CString AppName, 
										  int resetmb,
										  int resetbox,
										  int OFreq,
										  int *Freq, 
										  int *Restart, 
										  int *Counter);

// Dialog Data
	//{{AFX_DATA(CWD_Test_SoftwareDlg)
	enum { IDD = IDD_WD_TEST_SOFTWARE_DIALOG };
	BOOL	m_resetbox1;
	BOOL	m_resetbox2;
	BOOL	m_resetbox3;
	BOOL	m_resetbox4;
	BOOL	m_resetbox5;
	BOOL	m_resetmb1;
	BOOL	m_resetmb2;
	BOOL	m_resetmb3;
	BOOL	m_resetmb4;
	BOOL	m_resetmb5;
	CString	m_app1;
	CString	m_app2;
	CString	m_app3;
	CString	m_app4;
	CString	m_app5;
	int		m_counter1;
	int		m_counter2;
	int		m_counter3;
	int		m_counter4;
	int		m_counter5;
	int		m_freq1;
	int		m_freq2;
	int		m_freq3;
	int		m_freq4;
	int		m_freq5;
	int		m_restartbox1;
	int		m_restartbox2;
	int		m_restartbox3;
	int		m_restartbox4;
	int		m_restartbox5;
	CString	m_startdate;
	int		m_starthour;
	int		m_startmin;
	CString	m_stopdate;
	int		m_stophour;
	int		m_stopmin;
	CWatchDog_OCX	m_WD;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWD_Test_SoftwareDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CWD_Test_SoftwareDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBsetstart();
	afx_msg void OnBsetstop();
	afx_msg void OnBStartNow();
	afx_msg void OnBStopNow();
	afx_msg void OnBsave();
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WD_TEST_SOFTWAREDLG_H__6679B5A1_C191_439A_97FB_7B41EF9ABCF8__INCLUDED_)
